<template>
  <div id="the-posts">
    <div v-for="(post, index) in postsOrdered" :key="`post-${index}`">
      <ThePost
        :id="`post-${index}`"
        :user="post.user"
        :post="post"
        :now="props.now"
        :admin="props.admin"
        @intersecting="intersecting"
      />
    </div>
  </div>
</template>

<script setup>
import { computed, ref } from 'vue'
import { orderNumerically } from '@/scripts/utils'
import ThePost from '@/components/ThePost.vue'

const slicePosts = ref(5)

const props = defineProps({
  users: Array,
  posts: Array,
  now: Date,
  admin: Boolean
})

const postsOrdered = computed({
  get() {
    return [...props.posts]
      .sort((a, b) => orderNumerically(b, a, 'timestamp'))
      .slice(0, slicePosts.value)
  }
})

const intersecting = (i) => {
  if (slicePosts.value < i + 5) {
    slicePosts.value = i + 5
  }
}
</script>
